Computer-Based Instruction

             Terry Schieve
   Central Texas IBM PC Users Group

Computer-Based Instruction is an area
in which many programmers are
developing software. A common fallacy
is that many assume that anyone who
can write a program can develop a
good instructional program.  A truly
fine piece of instructional
programming is often due to planners
and instructors, as well as
programmers. At the present time, the
market is flooded with CBI programs,
many of which offer no educational
value.  Therefore, the potential
buyer must become familiar with some
means of identifying sound
educational programs from the lot.
Also, potential CBI programmers
should familiarize themselves with
the software currently available and
be able to evaluate program strengths
and weaknesses, thus avoiding a
repetition of common mistakes.

Many educators today divide
instructional software into several
categories, using "computer-based
instruction" as an umbrella term to
describe all of the software.
Obviously, these categories are not
rigid; they are used simply for
convenience. Some programs may
overlap these categories and
subcategories.

Computer Literacy - refers to
instructing students about computers.
Courses relating to computer hardware
and software such as programming
languages, would be included here.

o   Computer-Managed Instruction
    (CMI) - is a way to keep track of
    all the records that instructors
    usually must keep. These programs
    can range from gradebooks to
    course scheduling.

o   Utilities - are programs that
    could be considered as teachers'
    aides. Test generators and
    authoring languages could be
    examples of educational
    utilities.

o   Computer-Aided (or Assisted)
    Instruction - is probably the
    largest group of educational
    materials. CAI is using the
    computer to teach students about
    another subject, such as math,
    foreign languages or social
    studies. A point to emphasize
    here is that the student need not
    be aware of any specific
    functions of the computer, except
    for those that are absolutely
    necessary to run the software.
    The computer is simply a tool,
    the same way a book or a
    television is used as an
    educational tool. One can
    subdivide CAI programs into
    smaller categories according to
    how the material is presented.

o   Drill and Practice - is probably
    the simplest form of
    instructional presentation. A
    drill program simply gives the
    student more practice in a
    subject that regular class time
    may not be able to offer. One can
    think of the old flash cards as a
    noncomputerized example of drill
    and practice.

o   Tutorials - tend to present some
    new information to a student,
    although they usually are not a
    total replacement of a
    conventional classroom course.
    The tutorial usually provides a
    step-by-step presentation of new
    material. It is constantly
    relating the new knowledge to the
    prior experience of the
    individual, often giving shout
    tests along the way to make sure
    that the student is following the
    presentation.

o   Computer Games - are often the
    most abused educational programs.
    The criteria for a game is
    usually 1)that it provide some
    type of learning experience and
    2)that there is a winner and a
    loser to the game. Educators do
    employ games as a method similar
    to a spelling bee, for example.
    In the spelling bee, one advances
    by correctly spelling words. The
    winner is the last person left
    who correctly spells all the
    words given. Computers also can
    effectively use the gaming
    method, even if the players are
    the student and the computer,
    rather than several students.

o   Simulations - are more than
    likely the most difficult
    programs to write.  Simulations
    attempt to show a part of reality
    to the student, whether it be
    physical phenomena or foreign
    language conversations. The big
    advantage of a simulation is that
    various problems can be presented
    for solution, and the student's
    solution will not have any
    adverse effects. For example, a
    person may want to learn how to
    fly an airplane. An instructor
    can teach the basics, but cannot
    put the student in the plane
    without seriously jeopardizing
    the student's safety. Using a
    simulation program, the student
    can try out all of the problems
    and learn from mistakes, without
    any disastrous results. Of
    course, a simulation is only as
    good as the programmer's
    imagination, so some simulations
    will prove to be far superior to
    others. These programs, if done
    correctly, can become extremely
    large and complex pieces of
    software.

o   Testing - is a final subcategory
    of CAI, and it serves to test a
    student at the computer terminal
    about a given subject. It is
    debatable whether this is indeed
    a subcategory of CAI or a utility
    or a CMI program (if it keeps
    track of scores).

    Hopefully, it is fairly evident
    by now that computer-based
    instruction is much more complex
    than one might expect. It is not
    simply a matter of a programmer
    sitting down and dashing off a
    program to reel off
    multiplication tables.
