Words From the Author: Script/PC

              Bob Seidel

Script/PC, is a recently announced
program for the IBM Personal Computer
and Personal Computer XT.  It is a
"Text Formatter", which is a type of
word processor offering advanced
functions and capabilities.  This
article describes a text formatter
and its capabilities.

What is a Text Formatter?

Understanding the answer to this
question is key to understanding the
function of Script/PC. The easiest
way to understand what a text
formatter is, is to realize that most
of the current word processing
programs are actually a combination
of two (or perhaps three, if you
count spelling check) distinct
functions.  These functions are the
Editor and the Formatter.

The Editor is the function that you
use to create and alter your document
on the display screen.  Such
functions as tabbing, insert/delete
characters, etc. are done by the
Editor.  You also use the editor to
put control characters or control
words (sometimes called "dot
commands") into your text.

The Formatter is the function that
actually prints out the formatted
letter or document.  In doing this,
it may interpret those "dot commands"
and re-format the words you have
entered with the Editor, based on the
parameters (such as the length of the
line or page) you have set up.

Script/PC is only a formatter; no
editor is included.  It uses only
"dot commands". Since it is a
separate program, Script/PC can
provide more function than a program
which combines both editing and
formatting.  You can use any common
editor to create the Script/PC input
files, such as EDLIN, or the IBM
Personal and Professional Editors.
Using the editor of your choice, you
create Script/PC input files on
diskette or hard disk, and you can
combine them with previously written
files containing, for example,
standard setup or macros.  Script/PC
reads these input files and formats
them to create your final document.

A combination of one of these
editors, Word Proof (the spelling
check program) and Script/PC is a
total package providing the most
advanced level of word processing
function.  Of course, this function
has its price.  Although Script/PC is
easy to use, it is complex.  Its
power is needed more for complex or
professional documents.  There are
easier programs to use to write a
letter home to Mom!

When to use Script/PC

This question is often asked. The
answer lies in recognizing how
extensively you must revise your
document and how great the need is to
standardize your documents. If you
are doing a one-shot document, that
you will never revise, the average
word processor is probably
sufficient.

However, if, for example, you work
for an engineering firm that
constantly revises documents and
proposals and needs conformity of
format among documents, Script/PC is
for you.  You will find it much
easier to define standard structures
(or objects) such as paragraphs,
lists, bullets, etc. and to revise
and correct your document using
Script/PC.

Obviously, if you need some of the
advanced functions that Script/PC
provides, such as footnotes or index,
your choice is clear.

What Script/PC Can Do

Script/PC provides a wide variety of
document formatting functions.  These
functions are performed by the
program - you don't do anything
except enter the words themselves and
the appropriate "dot commands", which
are called either control words or
tags in Script/PC.  A partial list of
these functions includes:

o   "Normal" formatting; including
    filling the correct number of
    words per line and lines per
    page, smooth right hand margin if
    requested, etc.
o   Highlighting; including
    centering, underscoring, bold or
    emphasized print, capitalization,
    right margin alignment
o   Full page formatting; top and
    bottom titles, running headers,
    automatic page, date or other
    symbol insertion
o   Full indent control; left and
    right indent, un-indent, offset,
    tabs
o   Font definition allowing grouping
    of highlighting into defined
    fonts
o   Box generation; text can be
    grouped inside boxes - can be
    used for tables, figures, etc.
o   Macros; an extensive macro
    definition facility, including
    branching, nesting and recursion
o   Variable symbols; similar to
    program variables
o   Full conditional sense
o   Automatic revision codes
o   Files can be any length; input
    files can be nested or
    concatenated
o   Two column mode
o   Automatic Index generation
o   Automatic Table of Contents
    generation
o   Footnote capability
o   Chapter and sub-chapter headings
o   Dynamic interaction during
    formatting
o   Character translations
o   Diagnostic trace mode

General Markup Language (GML)

All of the above features can be
obtained by using the various control
words that Script/PC supports.  These
control words, however, tend to be
oriented towards the physical layout
of the document, rather than its
logical components.  For example, at
the start of a paragraph you might
use the control word "Indent Line",
rather than "Start Paragraph".  In
order to provide this "object"
orientation to Script/PC, and also to
provide an easier to learn set of
commands, Script/PC has a GML
library. GML also is provided with
Script/PC's large systems relative,
SCRIPT/VS.

GML is object oriented - paragraphs,
lists, figures, etc.  To use GML you
merely select which object you
desire, and all the correct
formatting will be done
automatically.

Highlights of GML objects and
function are

o   Title Page; including title,
    date, author and address
o   Table of Contents, List of
    Illustrations, and Index
o   Abstract and Preface
o   Paragraphs, highlighted phrases,
    quotations, headings, citations,
    notes
o   Four types of lists (can be
    nested)
o   Figures and examples
o   Footnotes

GML is supplied as a macro library
(the file name is GMLLIB.SCT) which
optionally can be included in any
Script/PC run.

Documentation

To assist you in learning these
functions, Script/PC comes with three
manuals.  Book 1 contains seven
chapters on "How to Use Script/PC";
Book 2 is a complete Quick Reference;
and Book 3 is a detailed Reference
Manual, containing approximately 394
pages in eight chapters, appendices
and a glossary.
